# revision of the original gled-grdmon package
%global rev 1

%global packagename gled-xrdmon
%global version     _VERSION_
%global release     %{rev}.%{dist}

%global prefix    /opt/gled
%global buildroot %{_tmppath}/%{packagename}-%{version}-%{release}-root-%(%{__id_u} -n)

%global service_name  gled-xrdmon
%global service_user  nobody
%global service_group nobody

# legacy support
%global __var /var

Summary:        Gled XRootD transfers monitoring
Name:           %{packagename}
Version:        %{version}
Release:        %{release}
License:        GPLv3
Group:          Applications/Monitoring
URL :           https://desire.physics.ucsd.edu/foswiki/bin/view/Main/XrdMon
Vendor:         ARDA Dashboard
BuildRoot:      %{buildroot}
BuildArch:      x86_64

# disable automatic dependency processing
# all necessary libraries are already in, should not be external requirements
AutoReqProv: no

Source0:        gled-xrdmon-%{version}-%{dist}.tar.gz
Source1:        configs.tar.gz


%description
Gled monitoring of XRootD files transfers

%prep
%setup -c -a0 -a1

# clean up SVN entries if any
find -name '.svn' | xargs rm -rf

# removing unnecessary files and directories
# The following is already called before making of the tarball
# cd gled
# ./gled/demos/XrdMon/rpm/cleanup-install-for-rpm.sh


%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}/%{prefix}
%{__mkdir_p} %{buildroot}/etc/gled/scripts
%{__mkdir_p} %{buildroot}/var/log/gled %{buildroot}/var/run/gled


%{__cp} -R gled/* %{buildroot}/%{prefix}

%{__install} -D -m 644 gled/demos/XrdMon/logrotate.d/gled-xrdmon %{buildroot}/etc/logrotate.d/%{service_name}

%{__cp} -R configs/* %{buildroot}/


%pre
# could create gled user

%post
if [ $1 -eq 1 ] ; then
    /usr/bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi


%preun
if [ $1 -eq 0 ] ; then
    for DAEMON in gled-xrdmon; do
        for INSTANCE in `/usr/bin/systemctl | grep $DAEMON@ | awk '{print $1;}'`; do
            /usr/bin/systemctl --no-reload disable $INSTANCE > /dev/null 2>&1 || :
            /usr/bin/systemctl stop $INSTANCE > /dev/null 2>&1 || :
        done
    done
fi

%postun
if [ $1 -ge 1 ] ; then
    /usr/bin/systemctl daemon-reload >/dev/null 2>&1 || :
    for DAEMON in gled-xrdmon; do
        for INSTANCE in `/usr/bin/systemctl | grep $DAEMON@ | awk '{print $1;}'`; do
            /usr/bin/systemctl try-restart $INSTANCE >/dev/null 2>&1 || :
        done
    done
fi

%clean
%{__rm} -rf %{buildroot}


%files
%defattr(-,root,root,-)
%{prefix}/
/etc/logrotate.d/%{service_name}
/etc/gled

%config(noreplace) /etc/gled/collectors.cfg
%attr(640,root,root) /etc/gled/collectors.cfg


%attr(-,%{service_user},%{service_group}) /var/log/gled
%attr(-,%{service_user},%{service_group}) /var/run/gled

%doc gled/README_gled gled/demos/XrdMon/ChangeLog

%changelog gled/demos/XrdMon/ChangeLog
